package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_STATI_RICHIESTA_PF_AMMTO")
public class DstatiRichiestaPfAmmto extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 4245367511L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DstatiRichiestaPfAmmto.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_STATO_RICH_PF_AMMTO", columnDefinition = "NUMBER(15)")
	private Long sequIdStatoRichPfAmmto;
	@NotNull

	@Column(name = "CODI_STATO_RICHIESTA", columnDefinition = "VARCHAR(50)")
	private String codiStatoRichiesta;
	@NotNull

	@Column(name = "DESC_STATO_RICHIESTA", columnDefinition = "VARCHAR(250)")
	private String descStatoRichiesta;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DstatiRichiestaPfAmmto(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DstatiRichiestaPfAmmto(DstatiRichiestaPfAmmtoKey dstatiRichiestaPfAmmtoKey, Long sequIdStatoRichPfAmmto,
			String codiStatoRichiesta, String descStatoRichiesta, String flagEliminato, String utenteUltimaModifica,
			Date dataUltimaModifica, Date dataInizioRecord, Date dataFineRecord) {
		super();

		this.dstatiRichiestaPfAmmtoKey = dstatiRichiestaPfAmmtoKey;

		this.sequIdStatoRichPfAmmto = sequIdStatoRichPfAmmto;
		this.codiStatoRichiesta = codiStatoRichiesta;
		this.descStatoRichiesta = descStatoRichiesta;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDstatiRichiestaPfAmmto")
	@OneToMany(mappedBy = "theDstatiRichiestaPfAmmto", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DrichPianifFerieAmmto> theDrichPianifFerieAmmto = new ArrayList<>();

	// PARENTS

	// GETTER/SETTER
	/**
	 * @return the sequIdStatoRichPfAmmto
	 */
	public Long getSequIdStatoRichPfAmmto() {
		return this.sequIdStatoRichPfAmmto;
	}

	/**
	 * @param sequIdStatoRichPfAmmto to set
	 */
	public void setSequIdStatoRichPfAmmto(Long sequIdStatoRichPfAmmto) {
		this.sequIdStatoRichPfAmmto = sequIdStatoRichPfAmmto;
	}

	/**
	 * @return the codiStatoRichiesta
	 */
	public String getCodiStatoRichiesta() {
		return this.codiStatoRichiesta;
	}

	/**
	 * @param codiStatoRichiesta to set
	 */
	public void setCodiStatoRichiesta(String codiStatoRichiesta) {
		this.codiStatoRichiesta = codiStatoRichiesta;
	}

	/**
	 * @return the descStatoRichiesta
	 */
	public String getDescStatoRichiesta() {
		return this.descStatoRichiesta;
	}

	/**
	 * @param descStatoRichiesta to set
	 */
	public void setDescStatoRichiesta(String descStatoRichiesta) {
		this.descStatoRichiesta = descStatoRichiesta;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DrichPianifFerieAmmto
	 */
	public Collection<DrichPianifFerieAmmto> getTheDrichPianifFerieAmmto() {
		return theDrichPianifFerieAmmto;
	}

	/**
	 * @param aDrichPianifFerieAmmtoList to set
	 */
	public void setTheDrichPianifFerieAmmto(Collection<DrichPianifFerieAmmto> aDrichPianifFerieAmmtoList) {
		theDrichPianifFerieAmmto = aDrichPianifFerieAmmtoList;
	}

	/// ADD CHILD
	public void addDrichPianifFerieAmmto(DrichPianifFerieAmmto drichPianifFerieAmmto) {
		theDrichPianifFerieAmmto.add(drichPianifFerieAmmto);
	}

	// PARENT GETTER/SETTER

	// PARENT ID GETTER/SETTER

	// PARENT OBJECT TITLE

	// PARENT OBJECT KEY

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDstatiRichiestaPfAmmtoKey());
	}

	public String getObjectKeyById(DstatiRichiestaPfAmmtoKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dstatiRichiestaPfAmmtoKey = new DstatiRichiestaPfAmmtoKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiStatoRichiesta());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DstatiRichiestaPfAmmtoKey dstatiRichiestaPfAmmtoKey;

	// GETTER/SETTER CK
	/**
	 * @return the dstatiRichiestaPfAmmtoKey
	 */
	public DstatiRichiestaPfAmmtoKey getDstatiRichiestaPfAmmtoKey() {
		return this.dstatiRichiestaPfAmmtoKey;
	}

	/**
	 * @param dstatiRichiestaPfAmmtoKey to set
	 */
	public void setDstatiRichiestaPfAmmtoKey(DstatiRichiestaPfAmmtoKey dstatiRichiestaPfAmmtoKey) {
		this.dstatiRichiestaPfAmmtoKey = dstatiRichiestaPfAmmtoKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dstatiRichiestaPfAmmtoKey == null) {
			dstatiRichiestaPfAmmtoKey = new DstatiRichiestaPfAmmtoKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DstatiRichiestaPfAmmto that = (DstatiRichiestaPfAmmto) o;
		return dstatiRichiestaPfAmmtoKey != null
				&& Objects.equals(dstatiRichiestaPfAmmtoKey, that.dstatiRichiestaPfAmmtoKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dstatiRichiestaPfAmmtoKey);
	}
}
